export let base = {
    methods: {
        reduceData(data) {
            try {
                let arr = data;
                let year, code, quota1;
                return arr.map(item => {
                    if (item.quota1 != quota1 && (code == undefined || item.code == code) && (item.year == year || year == undefined)) {
                        quota1 = item.quota1;
                        item.quota1Row = arr.filter(child => {
                            return child.year == item.year && child.code == item.code && item.quota1 == child.quota1
                        }).length
                    }
                    if (item.code != code && (year == undefined || year == item.year)) {
                        code = item.code;
                        quota1 = item.quota1;
                        item.quota1Row = arr.filter(child => {
                            return child.year == item.year && child.code == item.code && item.quota1 == child.quota1
                        }).length
                        item.codeRow = arr.filter(child => {
                            return child.year == item.year && child.code == item.code
                        }).length
                    }
                    if (item.year != year) {
                        year = item.year;
                        code = item.code;
                        item.codeRow = arr.filter(child => {
                            return child.year == item.year && child.code == item.code
                        }).length
                        item.yearRow = arr.filter(child => {
                            return child.year == item.year
                        }).length;
                    }
                    return item;
                })
            } catch(e) {
                console.log(e)
            }
        },
        arraySpanMethod({ row, column, rowIndex, columnIndex }) {
            if (columnIndex == 1) {
                if (row.yearRow) {
                    return {
                        rowspan: row.yearRow,
                        colspan: 1
                    }
                } else {
                    return {
                        rowspan: 0,
                        colspan: 1
                    }
                }
            }
            if (columnIndex == 2 || columnIndex == 3) {
                if (row.codeRow) {
                    return {
                        rowspan: row.codeRow,
                        colspan: 1
                    }
                } else {
                    return {
                        rowspan: 0,
                        colspan: 1
                    }
                }
            }
            if (columnIndex == 4) {
                if (row.quota1Row) {
                    return {
                        rowspan: row.quota1Row,
                        colspan: 1
                    }
                } else {
                    return {
                        rowspan: 0,
                        colspan: 1
                    }
                }
            }
        }
    },
}


export let assessing = {
    methods: {
        reduceData(data) {
            let arr = data;
            let quota1, quota2;
            return arr.map(item => {
                if (item.quota2 != quota2 && (quota1 == undefined || quota1 == item.quota1)) {
                    quota2 = item.quota2;
                    item.quota2Row = arr.filter(child => {
                        return child.quota1 == item.quota1 && child.quota2 == item.quota2
                    }).length
                }

                if (item.quota1 != quota1) {
                    quota1 = item.quota1;
                    quota2 = item.quota2;
                    item.quota2Row = arr.filter(child => {
                        return child.quota1 == item.quota1 && child.quota2 == item.quota2
                    }).length
                    item.quota1Row = arr.filter(child => {
                        return child.quota1 == item.quota1
                    }).length;
                }
                return item;
            })
        },
        arraySpanMethod({ row, column, rowIndex, columnIndex }) {
            if (columnIndex == 1) {
                if (row.quota1Row) {
                    return {
                        rowspan: row.quota1Row,
                        colspan: 1
                    }
                } else {
                    return {
                        rowspan: 0,
                        colspan: 1
                    }
                }
            }
            if (columnIndex == 2) {
                if (row.quota2Row) {
                    return {
                        rowspan: row.quota2Row,
                        colspan: 1
                    }
                } else {
                    return {
                        rowspan: 0,
                        colspan: 1
                    }
                }
            }
        }
    },
}

export let quota = {
    methods: {
        reduceData(data) {
            let arr = data;
            let quota;
            return arr.map(item => {
                if (item.quota != quota) {
                    quota = item.quota;
                    item.quotaRow = arr.filter(child => {
                        return child.quota == item.quota
                    }).length
                }


                return item;
            })
        },
        arraySpanMethod({ row, column, rowIndex, columnIndex }) {
            if (columnIndex == 1) {
                if (row.quotaRow) {
                    return {
                        rowspan: row.quotaRow,
                        colspan: 1
                    }
                } else {
                    return {
                        rowspan: 0,
                        colspan: 1
                    }
                }
            }

        }
    },
}

